#ifndef APPLICATION_H
#define APPLICATION_H

#include "acframe_application.h"
#include "acgfx_graphics.h"
#include <vector>

namespace acGraphics
{
	class CFont;
	class CCamera;
}

struct ID3DXMesh;
struct IDirect3DTexture9;

class CApplication : public acFramework::CBaseApplication, acGraphics::IHasDeviceObjects
{
public:
	CApplication();
	~CApplication();

	int  Init();
	void Uninit();
	void Frame();
	void Render();

protected:
	void RenderScene(bool shadowMap, acGraphics::CCamera *camera);

	int  InitializeDeviceObjects();
	void ReinitializeDeviceObjects(acGraphics::CGraphics *gfx);
	void ReleaseDeviceObjects();

	acGraphics::CFont *font;
	acGraphics::CCamera *camera;
	acGraphics::CCamera *light;

	std::vector<ID3DXMesh*> meshes;
	std::vector<D3DXVECTOR3> positions;
	IDirect3DTexture9 *shadowMap;
};

#endif